<template>
  <div>
    <q-table
      title="Available services"
      :data="services"
      :filter="filter"
      :columns="columns"
      row-key="name"
      style="margin:50px"
    >
      <template v-slot:top-right>
        <q-input
          borderless
          dense
          debounce="300"
          v-model="filter"
          placeholder="Search"
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>

      <template v-slot:body-cell-actions="props">
        <q-td :props="props">
          <q-btn
            class="button"
            outline
            style="margin-right:20px"
            @click="editService(props.row)"
            round
            color="primary"
            icon="create"
          />
          <q-btn
            class="button"
            outline
            @click="removeService(props.row)"
            round
            color="negative"
            icon="delete"
          />
        </q-td>
      </template>

      <template v-slot:top-left>
        <q-btn color="primary" label="ADD" outline @click="addService" />

        <q-space />
      </template>
    </q-table>

    <q-dialog v-model="card" style="width:60%">
      <q-card class="my-card full-width">
        <q-card-section class="row text-h5 ellipsis">
          <div class="col-3 text-grey" v-if="state === 'ADD'">
            Add service
          </div>
          <div class="col-3 text-grey" v-else>Edit service</div>
        </q-card-section>
        <q-card-section>
          <div class="row q-mb-md">
            <div class="col-3 text-grey">Name:</div>
            <q-select
              outlined
              v-model="selectedService.name"
              :options="servicesOptions"
              dense
              label="Name"
            />
          </div>

          <div class="row q-mb-md">
            <div class="col-3 text-grey">Description:</div>
            <q-select
              outlined
              v-model="selectedService.description"
              :options="descriptionOptions"
              dense
              label="Description"
            />
          </div>
          <div class="row q-mb-md">
            <div class="col-3 text-grey">Category:</div>

            <q-select
              outlined
              v-model="selectedService.category"
              :options="categoryOptions"
              dense
              label="Category"
            />
          </div>
        </q-card-section>
        <q-card-section>
          <q-card-actions align="around">
            <q-btn
              icon="add"
              outline
              color="primary"
              @click="executeAddService"
              v-if="state === 'ADD'"
              >Add</q-btn
            >
            <q-btn
              icon="create"
              outline
              color="primary"
              v-else
              @click="executeSaveService"
              >Edit</q-btn
            >
          </q-card-actions>
        </q-card-section>
      </q-card>
    </q-dialog>
  </div>
</template>
<script>
export default {
  name: "Service",
  data() {
    return {
      state: "VIEW",
      tab: "services",
      filter: "",
      card: false,
      editMedicService: "",
      selectedService: {},

      columns: [
        {
          name: "type",
          required: true,
          label: "Type",
          align: "left",
          field: row => row.serviceType,
          format: val => `${val}`,
          sortable: true
        },
        {
          name: "curency",
          required: true,
          label: "Currency",
          align: "left",
          field: row => row.currency,
          format: val => `${val}`,
          sortable: true
        },
        {
          name: "administrationFee",
          required: true,
          label: "Administration fee",
          align: "left",
          field: row => row.administrationFee,
          format: val => `${val} RON`,
          sortable: true
        },
        {
          name: "processFee",
          required: true,
          label: "Process fee",
          align: "left",
          field: row => row.processFee,
          format: val => `${val} RON`,
          sortable: true
        },
        {
          name: "dae",
          required: true,
          label: "DAE",
          align: "left",
          field: row => row.dae,
          format: val => `${val}%`,
          sortable: true
        },
        {
          name: "actions",
          label: "Action"
        }
      ]
    };
  },
  beforeMount() {
    const user = this.$q.localStorage.getItem("user");
    if (!user) {
      this.$router.push("/auth");
    } else {
      // this.$store.dispatch("data/loadServices");
      // this.$store.dispatch("data/loadMedicServices");
    }
  },
  methods: {
    addService() {
      this.state = "ADD";
      this.card = true;
      this.selectedService = {
        name: "",
        description: "",
        category: ""
      };
    },
    editService(service) {
      this.state = "EDIT";
      this.card = true;
      this.selectedService = {
        ...service
      };
    },
    removeService(service) {
      this.$q
        .dialog({
          title: "Confirmation",
          message: `Do you want to delete ${service.name}?`,
          cancel: true,
          persistent: true
        })
        .onOk(() => {
          this.$axios
            .delete(`/api/services/${service.id}`)
            .then(response => {
              this.$q.notify({
                color: "green",

                message: response.data.message,
                icon: "arrow_forward"
              });
              this.$store.dispatch("data/loadServices");
              this.$store.dispatch("data/loadAllExperiences");
            })
            .catch(error => {
              switch (error.response.status) {
                case 400: {
                  error.response.data.errors.forEach(element => {
                    this.$q.notify({
                      color: "negative",
                      message: element
                    });
                  });
                  break;
                }
                default: {
                  this.$q.notify({
                    color: "negative",
                    message: error.response.data.message
                  });
                }
              }
            });
        });
    },
    executeSaveService() {
      this.$axios
        .put(`/api/services/${this.selectedService.id}`, {
          ...this.selectedService
        })
        .then(response => {
          this.$q.notify({
            color: "green",

            message: response.data.message,
            icon: "arrow_forward"
          });
          this.$store.dispatch("data/loadServices");
          this.$store.dispatch("data/loadMedicServices");
          this.card = false;
        })
        .catch(error => {
          switch (error.response.status) {
            case 400: {
              error.response.data.errors.forEach(element => {
                this.$q.notify({
                  color: "negative",
                  message: element
                });
              });
              break;
            }
            default: {
              this.$q.notify({
                color: "negative",
                message: error.response.data.message
              });
            }
          }
        });
    },

    executeAddService() {
      this.$axios
        .post("/api/services", {
          ...this.selectedService
        })
        .then(response => {
          this.$q.notify({
            color: "green",

            message: response.data.message,
            icon: "arrow_forward"
          });
          this.$store.dispatch("data/loadServices");
          this.$store.dispatch("data/loadMedicServices");
          this.card = false;
        })
        .catch(error => {
          switch (error.response.status) {
            case 400: {
              error.response.data.errors.forEach(element => {
                this.$q.notify({
                  color: "negative",
                  message: element
                });
              });
              break;
            }
            default: {
              this.$q.notify({
                color: "negative",
                message: error.response.data.message
              });
            }
          }
        });
    },
    updateOffer(id) {
      this.$axios
        .put("/api/services/medic", {
          serviceId: id
        })
        .then(response => {
          this.$store.dispatch("data/loadMedicServices");
          this.$q.notify({
            color: "green",

            message: response.data.message,
            icon: "arrow_forward"
          });
        })
        .catch(error => {
          switch (error.response.status) {
            case 400: {
              error.response.data.errors.forEach(element => {
                this.$q.notify({
                  color: "negative",
                  message: element
                });
              });
              break;
            }
            default: {
              this.$q.notify({
                color: "negative",
                message: error.response.data.message
              });
            }
          }
        });
    }
  },
  computed: {
    services() {
      return this.$store.getters["data/getServices"];
    },
    medicServices() {
      const user = this.$q.localStorage.getItem("user");

      const list = this.$store.getters["data/getMedicServices"].find(
        item => item.id == user.id
      );

      return list ? list.services : [];
    }
  }
};
</script>
